Package org.apache.sis.metadata.iso.spatial

# Class DefaultDimension

Object
AbstractMetadata
ModifiableMetadata
ISOMetadata
DefaultDimension

All Implemented Interfaces:
  `Serializable`, `Emptiable`, `LenientComparable`, `IdentifiedObject`, `Dimension`

@TitleProperty(name="dimensionName") public class DefaultDimension extends ISOMetadata implements Dimension
Axis properties. The following properties are mandatory in a well-formed metadata according ISO 19115:
`MD_Dimension` `├─dimensionName……` Name of the axis. `└─dimensionSize……` Number of elements along the axis.

## Limitations

- Instances of this class are not synchronized for multi-threading. Synchronization, if needed, is caller's responsibility.
- Serialized objects of this class are not guaranteed to be compatible with future Apache SIS releases. Serialization support is appropriate for short term storage or RMI between applications running the same version of Apache SIS. For long term storage, use `XML` instead.

Since:
  0.3
See Also:
  - Serialized Form

Defined in the `sis-metadata` module

- ## Nested Class Summary

  ## Nested classes/interfaces inherited from class ModifiableMetadata

  `ModifiableMetadata​.State`

- ## Field Summary

  ### Fields inherited from class ISOMetadata

  `identifiers`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `DefaultDimension()`
  Constructs an initially empty dimension.
  `DefaultDimension(Dimension object)`
  Constructs a new instance initialized with the values from the specified metadata object.
  `DefaultDimension(DimensionNameType dimensionName, int dimensionSize)`
  Creates a dimension initialized to the given type and size.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `static DefaultDimension`
  `castOrCopy(Dimension object)`
  Returns a SIS metadata implementation with the values of the given arbitrary implementation.
  `InternationalString`
  `getDimensionDescription()`
  Return the axis dimension description.
  `DimensionNameType`
  `getDimensionName()`
  Returns the name of the axis.
  `Integer`
  `getDimensionSize()`
  Returns the number of elements along the axis.
  `InternationalString`
  `getDimensionTitle()`
  Returns the enhancement / modifier of the dimension name.
  `Double`
  `getResolution()`
  Returns the degree of detail in the grid dataset.
  `void`
  `setDimensionDescription(InternationalString newValue)`
  Sets the axis dimension description.
  `void`
  `setDimensionName(DimensionNameType newValue)`
  Sets the name of the axis.
  `void`
  `setDimensionSize(Integer newValue)`
  Sets the number of elements along the axis.
  `void`
  `setDimensionTitle(InternationalString newValue)`
  Sets the enhancement / modifier of the dimension name.
  `void`
  `setResolution(Double newValue)`
  Sets the degree of detail in the grid dataset.

  ### Methods inherited from class ISOMetadata

  `getIdentifier, getIdentifierMap, getIdentifiers, getStandard, setIdentifier, transitionTo`

  ### Methods inherited from class ModifiableMetadata

  `checkWritePermission, collectionType, copyCollection, copyList, copyMap, copySet, deepCopy, nonNullCollection, nonNullList, nonNullMap, nonNullSet, singleton, state, writeCollection, writeList, writeMap, writeSet`

  ### Methods inherited from class AbstractMetadata

  `asMap, asTreeTable, equals, equals, getInterface, hashCode, isEmpty, prune, toString`

  ### Methods inherited from class Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- ## Constructor Details

  - ### DefaultDimension

    public DefaultDimension()
    Constructs an initially empty dimension.

  - ### DefaultDimension

    public DefaultDimension(DimensionNameType dimensionName, int dimensionSize)
    Creates a dimension initialized to the given type and size.
    Parameters:
      `dimensionName` - the name of the axis, or `null` if none, or `null` if none.
      `dimensionSize` - the number of elements along the axis, or `null` if none.
    Throws:
      `IllegalArgumentException` - if `dimensionSize` is negative.

  - ### DefaultDimension

    public DefaultDimension(Dimension object)
    Constructs a new instance initialized with the values from the specified metadata object. This is a shallow copy constructor, since the other metadata contained in the given object are not recursively copied.
    Note on properties validation: This constructor does not verify the property values of the given metadata (e.g. whether it contains unexpected negative values). This is because invalid metadata exist in practice, and verifying their validity in this copy constructor is often too late. Note that this is not the only hole, as invalid metadata instances can also be obtained by unmarshalling an invalid XML document.
    Parameters:
      `object` - the metadata to copy values from, or `null` if none.
    See Also:
      - `castOrCopy(Dimension)`

- ## Method Details

  - ### castOrCopy

    public static DefaultDimension castOrCopy(Dimension object)
    Returns a SIS metadata implementation with the values of the given arbitrary implementation. This method performs the first applicable action in the following choices:
    - If the given object is `null`, then this method returns `null`.
    - Otherwise if the given object is already an instance of `DefaultDimension`, then it is returned unchanged.
    - Otherwise a new `DefaultDimension` instance is created using the copy constructor and returned. Note that this is a shallow copy operation, since the other metadata contained in the given object are not recursively copied.
    Parameters:
      `object` - the object to get as a SIS implementation, or `null` if none.
    Returns:
      a SIS implementation containing the values of the given object (may be the given object itself), or `null` if the argument was null.

  - ### getDimensionName

    public DimensionNameType getDimensionName()
    Returns the name of the axis.
    Specified by:
      `getDimensionName` in interface `Dimension`
    Returns:
      name of the axis, or `null`.

  - ### setDimensionName

    public void setDimensionName(DimensionNameType newValue)
    Sets the name of the axis.
    Parameters:
      `newValue` - the new dimension name.

  - ### getDimensionSize

    @ValueRange(minimum=0.0) public Integer getDimensionSize()
    Returns the number of elements along the axis.
    Specified by:
      `getDimensionSize` in interface `Dimension`
    Returns:
      number of elements along the axis, or `null`.

  - ### setDimensionSize

    public void setDimensionSize(Integer newValue)
    Sets the number of elements along the axis.
    Parameters:
      `newValue` - the new dimension size, or `null`.
    Throws:
      `IllegalArgumentException` - if the given value is negative.

  - ### getResolution

    @ValueRange(minimum=0.0, isMinIncluded=false) public Double getResolution()
    Returns the degree of detail in the grid dataset.
    Specified by:
      `getResolution` in interface `Dimension`
    Returns:
      degree of detail in the grid dataset, or `null`.

  - ### setResolution

    public void setResolution(Double newValue)
    Sets the degree of detail in the grid dataset.
    Parameters:
      `newValue` - the new resolution, or `null`.
    Throws:
      `IllegalArgumentException` - if the given value is NaN, zero or negative.

  - ### getDimensionTitle

    @UML(identifier="dimensionTitle", obligation=OPTIONAL, specification=ISO_19115) public InternationalString getDimensionTitle()
    Returns the enhancement / modifier of the dimension name.
    Example: dimensionName = "column", dimensionTitle = "longitude"
    Returns:
      the enhancement / modifier of the dimension name.
    Since:
      0.5

  - ### setDimensionTitle

    public void setDimensionTitle(InternationalString newValue)
    Sets the enhancement / modifier of the dimension name.
    Parameters:
      `newValue` - the new enhancement / modifier of the dimension name.
    Since:
      0.5

  - ### getDimensionDescription

    @UML(identifier="dimensionDescription", obligation=OPTIONAL, specification=ISO_19115) public InternationalString getDimensionDescription()
    Return the axis dimension description.
    Returns:
      the axis dimension description.
    Since:
      0.5

  - ### setDimensionDescription

    public void setDimensionDescription(InternationalString newValue)
    Sets the axis dimension description.
    Parameters:
      `newValue` - the new axis dimension description.
    Since:
      0.5